#! /usr/bin/perl

$prefix = "/usr/local";
$exec_prefix = "${prefix}";
$sbindir = "${exec_prefix}/sbin";
$PUREFTPD= "${exec_prefix}/sbin/pure-ftpd";

$conffile = shift or die "Usage: pure-config.pl <configuration file> [extra options]\n";
open CONF, "< $conffile" or die "Can't open $conffile : $!\n";
$flg = join ' ',@ARGV;
$flg .= ' ';

while (<CONF>) {
	chop;
	next if /^\s*#/o;
	/IPV4Only\s+yes/io && ($flg .= "-4 ") && next;	
	/ChrootEveryone\s+yes/io && ($flg .= "-A ") && next;
	/TrustedGID\s+(\d+)/io && ($flg .= "-a $1 ") && next;
	/BrokenClientsCompatibility\s+yes/io && ($flg .= "-b ") && next;
	/MaxClientsNumber\s+(\d+)/io && ($flg .= "-c $1 ") && next;
	/Daemonize\s+yes/io && ($flg .= "-B ") && next;
	/MaxClientsPerIP\s+(\d+)/io && ($flg .= "-C $1 ") && next;
	/VerboseLog\s+yes/io && ($flg .= "-d ") && next;
	/DisplayDotFiles\s+yes/io && ($flg .= "-D ") && next;
	/AnonymousOnly\s+yes/io && ($flg .= "-e ") && next;
	/NoAnonymous\s+yes/io && ($flg .= "-E ") && next;
	/SyslogFacility\s+(\S+)/io && ($flg .= "-f $1 ") && next;
	/FortunesFile\s+(\S+)/io && ($flg .= "-F $1 ") && next;	
	/DontResolve\s+yes/io && ($flg .= "-H ") && next;
	/MaxIdleTime\s+(\d+)/io && ($flg .= "-I $1 ") && next;
	/LDAPConfigFile\s+(\S+)/io && ($flg .= "-l $1 ") && next;
	/MySQLConfigFile\s+(\S+)/io && ($flg .= "-l $1 ") && next;
	/LimitRecursion\s+(\d+)\s+(\d+)/io && ($flg .= "-L $1:$2 ") && next;
	/AnonymousCanCreateDirs\s+yes/io && ($flg .= "-M ") && next;
	/MaxLoad\s+(\d+)/io && ($flg .= "-m $1 ") && next;
	/NATmode\s+yes/io && ($flg .= "-N ") && next;
	/CallUploadScript\s+yes/io && ($flg .= "-o ") && next;
	/PassivePortRange\s+(\d+)\s+(\d+)/io && ($flg .= "-p $1:$2 ") && next;
	/ForcePassiveIP\s+(\S+)/io && ($flg .= "-P $1 ") && next;
	/AnonymousRatio\s+(\d+)\s+(\d+)/io && ($flg .= "-q $1:$2 ") && next;
	/UserRatio\s+(\d+)\s+(\d+)/io && ($flg .= "-Q $1:$2 ") && next;
	/AntiWarez\s+yes/io && ($flg .= "-s ") && next;
	/Bind\s+(\S+)/io && ($flg .= "-S $1 ") && next;
	/AnonymousBandwidth\s+(\d+)/ && ($flg .= "-t $1 ") && next;
	/UserBandwidth\s+(\d+)/ && ($flg .= "-T $1 ") && next;
	/Umask\s+(\d+):(\d+)/ && ($flg .= "-U $1:$2 ") && next;
	/MinUID\s+(\d+)/ && ($flg .= "-u $1 ") && next;
	/AllowUserFXP\s+yes/ && ($flg .= "-w ") && next;
	/AllowAnonymousFXP\s+yes/ && ($flg .= "-W ") && next;
	/ProhibitDotFilesWrite\s+yes/io && ($flg .= "-x ") && next;
	/ProhibitDotFilesRead\s+yes/io && ($flg .= "-X ") && next;
	/AllowDotFiles\s+yes/io && ($flg .= "-z ") && next;
	/AutoRename\s+yes/io && ($flg .= "-r ") && next;
	/AnonymousCantUpload\s+yes/io && ($flg .= "-i ") && next;
	/TrustedIP\s+(\S+)/io && ($flg .= "-V $1 ") && next;
	/LogPID\s+yes/io && ($flg .= "-1 ") && next;
	/AltLog\s+(\S+)/io && ($flg .= "-O $1 ") && next;
	/NoChmod\s+yes/io && ($flg .= "-R ") && next;    
	/KeepAllFiles\s+yes/io && ($flg .= "-R ") && next;
	/CreateHomeDir\s+yes/io && ($flg .= "-j ") && next;
}
close CONF;

print "Running : $PUREFTPD $flg\n";
exec("$PUREFTPD $flg");
